package cn.ibizlab.core.analysis.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.analysis.domain.DABuild;
import cn.ibizlab.core.analysis.filter.DABuildSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[DABuild] 服务对象接口
 */
public interface IDABuildService extends IService<DABuild> {

    boolean create(DABuild et);
    void createBatch(List<DABuild> list);
    boolean update(DABuild et);
    void updateBatch(List<DABuild> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    DABuild get(String key);
    DABuild getDraft(DABuild et);
    DABuild check(DABuild et);
    boolean checkBatch(List<DABuild> etList);
    boolean checkKey(DABuild et);
    DABuild exportFile(DABuild et);
    boolean exportFileBatch(List<DABuild> etList);
    DABuild filterData(DABuild et);
    boolean filterDataBatch(List<DABuild> etList);
    DABuild run(DABuild et);
    boolean runBatch(List<DABuild> etList);
    boolean save(DABuild et);
    void saveBatch(List<DABuild> list);
    Page<DABuild> searchDefault(DABuildSearchContext context);
    List<DABuild> selectByModelId(String id);
    void removeByModelId(String id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


